#include "StdAfx.h"
#include ".\buttonscriptletplugin.h"
#include "XMLUtil.h"
#include "NButton.h"
#include "ScriptletConstant.h"
#include "ScriptletContainerFactory.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_BUTTON_NODE, CButtonScriptletPlugin);
CButtonScriptletPlugin::CButtonScriptletPlugin(void)
{
}

CButtonScriptletPlugin::~CButtonScriptletPlugin(void)
{
}
BOOL CButtonScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CNButton* pButton = reinterpret_cast<CNButton*>(pTarget);
		if (pButton == NULL)
		{
			return FALSE;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;

		USES_CONVERSION;
		//pushed
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_PUSHED_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_PUSHED_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			pButton->SetStyle(CAbstractButton::E_BUTTON_STYLE_PUSHED);

			BOOL bPushed = _tcsicmp(szValue, SCRIPTLET_TRUE_VALUE) == 0;
			pButton->SetPushed(bPushed);
		}
		//onaction
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_ONACTION_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_ONACTION_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			IActionListener* pAction = CScriptletContainerFactory::get_instance()->CreateAction(szValue);
			if ( NULL != pAction )
			{
				pButton->AddActionListener(pAction);
				pAction->Release();
			}
		}
		//except
		CRect rcBound;
		pButton->GetBounds(&rcBound);
		if (rcBound.Width() <= 0 || rcBound.Height() <= 0)
		{
			CSize sizePreferred;
			if (pButton->GetOrginPreferredSize(&sizePreferred))
			{
				pButton->MoveWindow(rcBound.left, rcBound.top, sizePreferred.cx, sizePreferred.cy);
			}
		}
	}
	return bSuccess;
}
CComponent* CButtonScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CNButton;
	return pComponent;
}